/* Copyright (C) 2009 Sakse Dalum
 * 
 * This file is part of Poddie.
 * 
 * Poddie Server is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Poddie is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * A copy of the GNU General Public License can be found in the file
 * LICENSE. 
 */

/*
 *                         gameobject.h  -  description
 *                         --------------------------------
 *   begin                : Tue Aug 13 2009
 *   copyright            : (C) 2009 by Sakse Dalum
 *   maintainer(s)        : Sakse "Don S" Dalum <don.s@yodanism.org>
 *   description          : Generic game object. Any variable or
 *                          function that belongs to all game objects, 
 *                          should be put in here.
 *
 */

/// //////////////////////////////////////////////////////////////// ///
///                          PREPROCESSOR                            ///
/// //////////////////////////////////////////////////////////////// ///

#ifndef header_gameobject
#define header_gameobject

#if _MSC_VER > 1000
#pragma once
#endif

#include "../precomp.h"

/// //////////////////////////////////////////////////////////////// ///
///                    YET TO BE DEFINED CLASSES                     ///
/// //////////////////////////////////////////////////////////////// ///

class World;

/// //////////////////////////////////////////////////////////////// ///
///                           DEFINITION                             ///
/// //////////////////////////////////////////////////////////////// ///

class GameObject {
public:
	// Constructors
	GameObject(float x, float y, float angle, float hspeed, float vspeed, World *world);
	GameObject();
	// Destructor
	virtual ~GameObject();
	
	// Object pointers
	World *world;
	
	// Variables
	float x, y, angle;
	float hspeed, vspeed;
	
	// Functions
	void set_angle(float);
	
	void set_x(float);
	float get_x();
	
	void set_y(float);
	float get_y();
	
	void set_hspeed(float);
	
	void set_vspeed(float);
};

#endif
