/* Copyright (C) 2009 Sakse Dalum
 * 
 * This file is part of Poddie.
 * 
 * Poddie Server is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Poddie is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * A copy of the GNU General Public License can be found in the file
 * LICENSE. 
 */

/*
 *                         missile.h  -  description
 *                         --------------------------------
 *   begin                : Sun Aug 16 2009
 *   copyright            : (C) 2009 by Sakse Dalum
 *   maintainer(s)        : Sakse "Don S" Dalum <don.s@yodanism.org>
 *   description          : Any flying missile.
 *
 */

/// //////////////////////////////////////////////////////////////// ///
///                          PREPROCESSOR                            ///
/// //////////////////////////////////////////////////////////////// ///

#ifndef header_missile
#define header_missile

#if _MSC_VER > 1000
#pragma once
#endif

#include "../precomp.h"
#include "player.h"
#include "gameobject.h"
#include "../world.h"

/// //////////////////////////////////////////////////////////////// ///
///                    YET TO BE DEFINED CLASSES                     ///
/// //////////////////////////////////////////////////////////////// ///

class Player;

/// //////////////////////////////////////////////////////////////// ///
///                           DEFINITION                             ///
/// //////////////////////////////////////////////////////////////// ///

class Missile : public GameObject {
public:
	// Constructors
	Missile(bool alive, float x, float y, float angle, float hspeed, float vspeed, Player *creator, World *world, CL_Sprite sprite);
	Missile();
	// Destructor
	~Missile();
	
	// Status
	bool alive;
	
	// Movement, position & direction
	float radius;
	
	// Collision
	bool collision;
	
	// Update
	virtual void update();
	
	// Sprite
	CL_Sprite sprite;
	CL_Sprite *sprite_collision;
	float collision_timer;
	
	// Draw
	void draw();
};

#endif

