/* Copyright (C) 2009 Sakse Dalum
 * 
 * This file is part of Poddie.
 * 
 * Poddie Server is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Poddie is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * A copy of the GNU General Public License can be found in the file
 * LICENSE. 
 */

/*
 *                         keyboard.h  -  description
 *                         --------------------------------
 *   begin                : Tue Aug 13 2009
 *   copyright            : (C) 2009 by Sakse Dalum
 *   maintainer(s)        : Sakse "Don S" Dalum <don.s@yodanism.org>
 *   description          : This object handles keyboard events.
 *
 */

/// //////////////////////////////////////////////////////////////// ///
///                          PREPROCESSOR                            ///
/// //////////////////////////////////////////////////////////////// ///
	
#ifndef header_poddiekeyboardinput
#define header_poddiekeyboardinput

#if _MSC_VER > 1000
#pragma once
#endif

#include "../precomp.h"

/// //////////////////////////////////////////////////////////////// ///
///                           DEFINITION                             ///
/// //////////////////////////////////////////////////////////////// ///

class Keyboard
{
public:
	// Constructor
	Keyboard();
	
	// Destructor
	~Keyboard();

protected:
	// Reset keys
	void reset(int);

public:
	// Set keys
	void set_pressed(int);
	void set_released(int);
	
	// Get key states
	bool pressed(int key_check);
	bool is_pressed(int key_check);
	bool released(int key_check);
	
	// Translate input
	int string_to_int(std::string);
	
	// Update
	void update();
	
protected:
	// Key states
	int key[65536];
};

#endif

